"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = translate;

var _templates = require("./templates");

var template = _interopRequireWildcard(_templates);

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _babelGenerator = require("babel-generator");

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function translate(analysis) {
  /*
  Based  on  the  analysis  from  the  analyzer  module  (_analysis),
  the appropriate code translation is created by calling the template
  with the corresponding mapper function which is inturn fed with the
  result  of  the  analysis (the first argument).
  */
  if (analysis.operation === void 0) analysis.operation = "select";

  if (!analysis.source) return {
    connectionString: analysis.module,
    collection: analysis.collection,
    translation: ""
  };

  var currentTranslation = (0, _babelGenerator2.default)(template[analysis.operation](analysis)()).code.replace(";", "");

  var _translate = translate(analysis.source),
      connectionString = _translate.connectionString,
      collection = _translate.collection,
      translation = _translate.translation;

  return {
    connectionString: connectionString,
    collection: collection,
    translation: translation.replace(";", ".") + currentTranslation
  };
}
//# sourceMappingURL=index.js.map