"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.select = select;
exports.count = count;
exports.remove = remove;
exports.insert = insert;
exports.slice = slice;
exports.sort = sort;
exports.map = map;

var _babelTemplate = require("babel-template");

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _babelGenerator = require("babel-generator");

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function select(analysis) {
  return (0, _babelTemplate2.default)("find();");
}

function count(analysis) {
  return (0, _babelTemplate2.default)("count();");
}

function remove(analysis) {
  return;
}

function insert(analysis) {
  return (0, _babelTemplate2.default)("insertMany(" + (0, _babelGenerator2.default)(analysis.itemsNode).code + ")");
}

function slice(analysis) {
  return analysis.to ? (0, _babelTemplate2.default)("skip(" + analysis.from + ").limit(" + (analysis.to - analysis.from) + ")") : (0, _babelTemplate2.default)("skip(" + analysis.from + ")");
}

function sort(analysis) {
  var sortDict = analysis.fields.reduce(function (acc, cur) {
    return acc + ", \"" + cur.field + "\": " + (cur.ascending ? 1 : -1);
  }, "").slice(2);

  return (0, _babelTemplate2.default)("sort({" + sortDict + "})");
}

function map(analysis) {
  var stringMap = analysis.fields.reduce(function (acc, cur) {
    return acc + ", \"" + cur.field + "\": " + cur.newField;
  }, "").slice(2);

  return (0, _babelTemplate2.default)("aggregate([\n    {\"$project\": {" + stringMap + "}}\n  ])");
}
//# sourceMappingURL=templates.js.map